/* query.c generated by valac 0.20.1, the Vala compiler
 * generated from query.vala, do not modify */

/*
 * Copyright (C) 2010 Michal Hruby <michal.mhr@gmail.com>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by Michal Hruby <michal.mhr@gmail.com>
 *
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <gee.h>


#define SYNAPSE_TYPE_QUERY_FLAGS (synapse_query_flags_get_type ())

#define SYNAPSE_TYPE_MATCHER_FLAGS (synapse_matcher_flags_get_type ())

#define SYNAPSE_TYPE_QUERY (synapse_query_get_type ())
typedef struct _SynapseQuery SynapseQuery;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

#define SYNAPSE_MATCH_TYPE_SCORE (synapse_match_score_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

typedef enum  {
	SYNAPSE_QUERY_FLAGS_INCLUDE_REMOTE = 1 << 0,
	SYNAPSE_QUERY_FLAGS_UNCATEGORIZED = 1 << 1,
	SYNAPSE_QUERY_FLAGS_APPLICATIONS = 1 << 2,
	SYNAPSE_QUERY_FLAGS_ACTIONS = 1 << 3,
	SYNAPSE_QUERY_FLAGS_AUDIO = 1 << 4,
	SYNAPSE_QUERY_FLAGS_VIDEO = 1 << 5,
	SYNAPSE_QUERY_FLAGS_DOCUMENTS = 1 << 6,
	SYNAPSE_QUERY_FLAGS_IMAGES = 1 << 7,
	SYNAPSE_QUERY_FLAGS_FILES = ((SYNAPSE_QUERY_FLAGS_AUDIO | SYNAPSE_QUERY_FLAGS_VIDEO) | SYNAPSE_QUERY_FLAGS_DOCUMENTS) | SYNAPSE_QUERY_FLAGS_IMAGES,
	SYNAPSE_QUERY_FLAGS_PLACES = 1 << 8,
	SYNAPSE_QUERY_FLAGS_INTERNET = 1 << 9,
	SYNAPSE_QUERY_FLAGS_TEXT = 1 << 10,
	SYNAPSE_QUERY_FLAGS_CONTACTS = 1 << 11,
	SYNAPSE_QUERY_FLAGS_ALL = 0xFFFFFFFFLL,
	SYNAPSE_QUERY_FLAGS_LOCAL_CONTENT = SYNAPSE_QUERY_FLAGS_ALL ^ SYNAPSE_QUERY_FLAGS_INCLUDE_REMOTE
} SynapseQueryFlags;

typedef enum  {
	SYNAPSE_MATCHER_FLAGS_NO_REVERSED = 1 << 0,
	SYNAPSE_MATCHER_FLAGS_NO_SUBSTRING = 1 << 1,
	SYNAPSE_MATCHER_FLAGS_NO_PARTIAL = 1 << 2,
	SYNAPSE_MATCHER_FLAGS_NO_FUZZY = 1 << 3
} SynapseMatcherFlags;

struct _SynapseQuery {
	gchar* query_string;
	gchar* query_string_folded;
	GCancellable* cancellable;
	SynapseQueryFlags query_type;
	guint max_results;
	guint query_id;
};

typedef enum  {
	SYNAPSE_SEARCH_ERROR_SEARCH_CANCELLED,
	SYNAPSE_SEARCH_ERROR_UNKNOWN_ERROR
} SynapseSearchError;
#define SYNAPSE_SEARCH_ERROR synapse_search_error_quark ()
typedef enum  {
	SYNAPSE_MATCH_SCORE_INCREMENT_MINOR = 2000,
	SYNAPSE_MATCH_SCORE_INCREMENT_SMALL = 5000,
	SYNAPSE_MATCH_SCORE_INCREMENT_MEDIUM = 10000,
	SYNAPSE_MATCH_SCORE_INCREMENT_LARGE = 20000,
	SYNAPSE_MATCH_SCORE_URI_PENALTY = 15000,
	SYNAPSE_MATCH_SCORE_POOR = 50000,
	SYNAPSE_MATCH_SCORE_BELOW_AVERAGE = 60000,
	SYNAPSE_MATCH_SCORE_AVERAGE = 70000,
	SYNAPSE_MATCH_SCORE_ABOVE_AVERAGE = 75000,
	SYNAPSE_MATCH_SCORE_GOOD = 80000,
	SYNAPSE_MATCH_SCORE_VERY_GOOD = 85000,
	SYNAPSE_MATCH_SCORE_EXCELLENT = 90000,
	SYNAPSE_MATCH_SCORE_HIGHEST = 100000
} SynapseMatchScore;



GType synapse_query_flags_get_type (void) G_GNUC_CONST;
GType synapse_matcher_flags_get_type (void) G_GNUC_CONST;
GType synapse_query_get_type (void) G_GNUC_CONST;
SynapseQuery* synapse_query_dup (const SynapseQuery* self);
void synapse_query_free (SynapseQuery* self);
void synapse_query_copy (const SynapseQuery* self, SynapseQuery* dest);
void synapse_query_destroy (SynapseQuery* self);
void synapse_query_init (SynapseQuery *self, guint query_id, const gchar* query, SynapseQueryFlags flags, guint num_results);
gboolean synapse_query_is_cancelled (SynapseQuery *self);
GQuark synapse_search_error_quark (void);
void synapse_query_check_cancellable (SynapseQuery *self, GError** error);
GeeList* synapse_query_get_matchers_for_query (const gchar* query, SynapseMatcherFlags match_flags, GRegexCompileFlags flags);
GType synapse_match_score_get_type (void) G_GNUC_CONST;
static void _vala_array_add6 (gchar*** array, int* length, int* size, gchar* value);
static void _vala_array_add7 (gchar*** array, int* length, int* size, gchar* value);
static gint __lambda3_ (gconstpointer a, gconstpointer b);
static gint ___lambda3__gcompare_func (gconstpointer a, gconstpointer b);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


GType synapse_query_flags_get_type (void) {
	static volatile gsize synapse_query_flags_type_id__volatile = 0;
	if (g_once_init_enter (&synapse_query_flags_type_id__volatile)) {
		static const GFlagsValue values[] = {{SYNAPSE_QUERY_FLAGS_INCLUDE_REMOTE, "SYNAPSE_QUERY_FLAGS_INCLUDE_REMOTE", "include-remote"}, {SYNAPSE_QUERY_FLAGS_UNCATEGORIZED, "SYNAPSE_QUERY_FLAGS_UNCATEGORIZED", "uncategorized"}, {SYNAPSE_QUERY_FLAGS_APPLICATIONS, "SYNAPSE_QUERY_FLAGS_APPLICATIONS", "applications"}, {SYNAPSE_QUERY_FLAGS_ACTIONS, "SYNAPSE_QUERY_FLAGS_ACTIONS", "actions"}, {SYNAPSE_QUERY_FLAGS_AUDIO, "SYNAPSE_QUERY_FLAGS_AUDIO", "audio"}, {SYNAPSE_QUERY_FLAGS_VIDEO, "SYNAPSE_QUERY_FLAGS_VIDEO", "video"}, {SYNAPSE_QUERY_FLAGS_DOCUMENTS, "SYNAPSE_QUERY_FLAGS_DOCUMENTS", "documents"}, {SYNAPSE_QUERY_FLAGS_IMAGES, "SYNAPSE_QUERY_FLAGS_IMAGES", "images"}, {SYNAPSE_QUERY_FLAGS_FILES, "SYNAPSE_QUERY_FLAGS_FILES", "files"}, {SYNAPSE_QUERY_FLAGS_PLACES, "SYNAPSE_QUERY_FLAGS_PLACES", "places"}, {SYNAPSE_QUERY_FLAGS_INTERNET, "SYNAPSE_QUERY_FLAGS_INTERNET", "internet"}, {SYNAPSE_QUERY_FLAGS_TEXT, "SYNAPSE_QUERY_FLAGS_TEXT", "text"}, {SYNAPSE_QUERY_FLAGS_CONTACTS, "SYNAPSE_QUERY_FLAGS_CONTACTS", "contacts"}, {SYNAPSE_QUERY_FLAGS_ALL, "SYNAPSE_QUERY_FLAGS_ALL", "all"}, {SYNAPSE_QUERY_FLAGS_LOCAL_CONTENT, "SYNAPSE_QUERY_FLAGS_LOCAL_CONTENT", "local-content"}, {0, NULL, NULL}};
		GType synapse_query_flags_type_id;
		synapse_query_flags_type_id = g_flags_register_static ("SynapseQueryFlags", values);
		g_once_init_leave (&synapse_query_flags_type_id__volatile, synapse_query_flags_type_id);
	}
	return synapse_query_flags_type_id__volatile;
}


GType synapse_matcher_flags_get_type (void) {
	static volatile gsize synapse_matcher_flags_type_id__volatile = 0;
	if (g_once_init_enter (&synapse_matcher_flags_type_id__volatile)) {
		static const GFlagsValue values[] = {{SYNAPSE_MATCHER_FLAGS_NO_REVERSED, "SYNAPSE_MATCHER_FLAGS_NO_REVERSED", "no-reversed"}, {SYNAPSE_MATCHER_FLAGS_NO_SUBSTRING, "SYNAPSE_MATCHER_FLAGS_NO_SUBSTRING", "no-substring"}, {SYNAPSE_MATCHER_FLAGS_NO_PARTIAL, "SYNAPSE_MATCHER_FLAGS_NO_PARTIAL", "no-partial"}, {SYNAPSE_MATCHER_FLAGS_NO_FUZZY, "SYNAPSE_MATCHER_FLAGS_NO_FUZZY", "no-fuzzy"}, {0, NULL, NULL}};
		GType synapse_matcher_flags_type_id;
		synapse_matcher_flags_type_id = g_flags_register_static ("SynapseMatcherFlags", values);
		g_once_init_leave (&synapse_matcher_flags_type_id__volatile, synapse_matcher_flags_type_id);
	}
	return synapse_matcher_flags_type_id__volatile;
}


void synapse_query_init (SynapseQuery *self, guint query_id, const gchar* query, SynapseQueryFlags flags, guint num_results) {
	guint _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_ = NULL;
	SynapseQueryFlags _tmp5_;
	guint _tmp6_;
	g_return_if_fail (query != NULL);
	memset (self, 0, sizeof (SynapseQuery));
	_tmp0_ = query_id;
	(*self).query_id = _tmp0_;
	_tmp1_ = query;
	_tmp2_ = g_strdup (_tmp1_);
	_g_free0 ((*self).query_string);
	(*self).query_string = _tmp2_;
	_tmp3_ = query;
	_tmp4_ = g_utf8_casefold (_tmp3_, (gssize) (-1));
	_g_free0 ((*self).query_string_folded);
	(*self).query_string_folded = _tmp4_;
	_tmp5_ = flags;
	(*self).query_type = _tmp5_;
	_tmp6_ = num_results;
	(*self).max_results = _tmp6_;
}


gboolean synapse_query_is_cancelled (SynapseQuery *self) {
	gboolean result = FALSE;
	GCancellable* _tmp0_;
	gboolean _tmp1_ = FALSE;
	_tmp0_ = (*self).cancellable;
	_tmp1_ = g_cancellable_is_cancelled (_tmp0_);
	result = _tmp1_;
	return result;
}


void synapse_query_check_cancellable (SynapseQuery *self, GError** error) {
	GCancellable* _tmp0_;
	gboolean _tmp1_ = FALSE;
	GError * _inner_error_ = NULL;
	_tmp0_ = (*self).cancellable;
	_tmp1_ = g_cancellable_is_cancelled (_tmp0_);
	if (_tmp1_) {
		GError* _tmp2_;
		_tmp2_ = g_error_new_literal (SYNAPSE_SEARCH_ERROR, SYNAPSE_SEARCH_ERROR_SEARCH_CANCELLED, "Cancelled");
		_inner_error_ = _tmp2_;
		if (_inner_error_->domain == SYNAPSE_SEARCH_ERROR) {
			g_propagate_error (error, _inner_error_);
			return;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
}


static gchar* string_strip (const gchar* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _result_;
	const gchar* _tmp1_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strstrip (_tmp1_);
	result = _result_;
	return result;
}


static void _vala_array_add6 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void _vala_array_add7 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static gint __lambda3_ (gconstpointer a, gconstpointer b) {
	gint result = 0;
	gconstpointer _tmp0_;
	GeeMapEntry* e1;
	gconstpointer _tmp1_;
	GeeMapEntry* e2;
	gconstpointer _tmp2_;
	gint _tmp3_;
	gconstpointer _tmp4_;
	gint _tmp5_;
	_tmp0_ = a;
	e1 = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_MAP_TYPE_ENTRY, GeeMapEntry);
	_tmp1_ = b;
	e2 = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_MAP_TYPE_ENTRY, GeeMapEntry);
	_tmp2_ = gee_map_entry_get_value (e2);
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_map_entry_get_value (e1);
	_tmp5_ = _tmp4_;
	result = ((gint) ((gintptr) _tmp3_)) - ((gint) ((gintptr) _tmp5_));
	return result;
}


static gint ___lambda3__gcompare_func (gconstpointer a, gconstpointer b) {
	gint result;
	result = __lambda3_ (a, b);
	return result;
}


GeeList* synapse_query_get_matchers_for_query (const gchar* query, SynapseMatcherFlags match_flags, GRegexCompileFlags flags) {
	GeeList* result = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* results;
	GRegex* re = NULL;
	const gchar* _tmp31_;
	gchar* _tmp32_ = NULL;
	gchar* _tmp33_;
	gchar** _tmp34_;
	gchar** _tmp35_ = NULL;
	gchar** _tmp36_;
	gint _tmp36__length1;
	gchar** individual_words;
	gint individual_words_length1;
	gint _individual_words_size_;
	gchar** _tmp37_;
	gint _tmp37__length1;
	SynapseMatcherFlags _tmp92_;
	const gchar* _tmp103_;
	gchar** _tmp104_;
	gchar** _tmp105_ = NULL;
	gchar** individual_chars;
	gint individual_chars_length1;
	gint _individual_chars_size_;
	gchar** _tmp106_ = NULL;
	gchar** escaped_chars;
	gint escaped_chars_length1;
	gint _escaped_chars_size_;
	gchar** _tmp107_;
	gint _tmp107__length1;
	gboolean _tmp111_ = FALSE;
	gboolean _tmp112_ = FALSE;
	SynapseMatcherFlags _tmp113_;
	gboolean _tmp115_;
	gboolean _tmp117_;
	gboolean _tmp128_ = FALSE;
	SynapseMatcherFlags _tmp129_;
	gboolean _tmp131_;
	GeeArrayList* _tmp142_;
	GeeArrayList* sorted_results;
	GeeSet* _tmp143_;
	GeeSet* _tmp144_;
	GeeSet* entries;
	GeeSet* _tmp145_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (query != NULL, NULL);
	_tmp0_ = gee_hash_map_new (G_TYPE_REGEX, (GBoxedCopyFunc) g_regex_ref, g_regex_unref, G_TYPE_INT, NULL, NULL, NULL, NULL, NULL);
	results = _tmp0_;
	{
		const gchar* _tmp1_;
		gchar* _tmp2_ = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_ = NULL;
		gchar* _tmp5_;
		GRegexCompileFlags _tmp6_;
		GRegex* _tmp7_;
		GRegex* _tmp8_;
		GRegex* _tmp9_;
		GRegex* _tmp10_;
		_tmp1_ = query;
		_tmp2_ = g_regex_escape_string (_tmp1_, -1);
		_tmp3_ = _tmp2_;
		_tmp4_ = g_strdup_printf ("^(%s)$", _tmp3_);
		_tmp5_ = _tmp4_;
		_tmp6_ = flags;
		_tmp7_ = g_regex_new (_tmp5_, _tmp6_, 0, &_inner_error_);
		_tmp8_ = _tmp7_;
		_g_free0 (_tmp5_);
		_g_free0 (_tmp3_);
		_tmp9_ = _tmp8_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch16_g_regex_error;
			}
			_g_regex_unref0 (re);
			_g_object_unref0 (results);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_g_regex_unref0 (re);
		re = _tmp9_;
		_tmp10_ = re;
		gee_abstract_map_set ((GeeAbstractMap*) results, _tmp10_, (gpointer) ((gintptr) ((gint) SYNAPSE_MATCH_SCORE_HIGHEST)));
	}
	goto __finally16;
	__catch16_g_regex_error:
	{
		GError* err = NULL;
		err = _inner_error_;
		_inner_error_ = NULL;
		_g_error_free0 (err);
	}
	__finally16:
	if (_inner_error_ != NULL) {
		_g_regex_unref0 (re);
		_g_object_unref0 (results);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	{
		const gchar* _tmp11_;
		gchar* _tmp12_ = NULL;
		gchar* _tmp13_;
		gchar* _tmp14_ = NULL;
		gchar* _tmp15_;
		GRegexCompileFlags _tmp16_;
		GRegex* _tmp17_;
		GRegex* _tmp18_;
		GRegex* _tmp19_;
		GRegex* _tmp20_;
		_tmp11_ = query;
		_tmp12_ = g_regex_escape_string (_tmp11_, -1);
		_tmp13_ = _tmp12_;
		_tmp14_ = g_strdup_printf ("^(%s)", _tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = flags;
		_tmp17_ = g_regex_new (_tmp15_, _tmp16_, 0, &_inner_error_);
		_tmp18_ = _tmp17_;
		_g_free0 (_tmp15_);
		_g_free0 (_tmp13_);
		_tmp19_ = _tmp18_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch17_g_regex_error;
			}
			_g_regex_unref0 (re);
			_g_object_unref0 (results);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_g_regex_unref0 (re);
		re = _tmp19_;
		_tmp20_ = re;
		gee_abstract_map_set ((GeeAbstractMap*) results, _tmp20_, (gpointer) ((gintptr) ((gint) SYNAPSE_MATCH_SCORE_EXCELLENT)));
	}
	goto __finally17;
	__catch17_g_regex_error:
	{
		GError* err = NULL;
		err = _inner_error_;
		_inner_error_ = NULL;
		_g_error_free0 (err);
	}
	__finally17:
	if (_inner_error_ != NULL) {
		_g_regex_unref0 (re);
		_g_object_unref0 (results);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	{
		const gchar* _tmp21_;
		gchar* _tmp22_ = NULL;
		gchar* _tmp23_;
		gchar* _tmp24_ = NULL;
		gchar* _tmp25_;
		GRegexCompileFlags _tmp26_;
		GRegex* _tmp27_;
		GRegex* _tmp28_;
		GRegex* _tmp29_;
		GRegex* _tmp30_;
		_tmp21_ = query;
		_tmp22_ = g_regex_escape_string (_tmp21_, -1);
		_tmp23_ = _tmp22_;
		_tmp24_ = g_strdup_printf ("\\b(%s)", _tmp23_);
		_tmp25_ = _tmp24_;
		_tmp26_ = flags;
		_tmp27_ = g_regex_new (_tmp25_, _tmp26_, 0, &_inner_error_);
		_tmp28_ = _tmp27_;
		_g_free0 (_tmp25_);
		_g_free0 (_tmp23_);
		_tmp29_ = _tmp28_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_REGEX_ERROR) {
				goto __catch18_g_regex_error;
			}
			_g_regex_unref0 (re);
			_g_object_unref0 (results);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_g_regex_unref0 (re);
		re = _tmp29_;
		_tmp30_ = re;
		gee_abstract_map_set ((GeeAbstractMap*) results, _tmp30_, (gpointer) ((gintptr) ((gint) SYNAPSE_MATCH_SCORE_VERY_GOOD)));
	}
	goto __finally18;
	__catch18_g_regex_error:
	{
		GError* err = NULL;
		err = _inner_error_;
		_inner_error_ = NULL;
		_g_error_free0 (err);
	}
	__finally18:
	if (_inner_error_ != NULL) {
		_g_regex_unref0 (re);
		_g_object_unref0 (results);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp31_ = query;
	_tmp32_ = string_strip (_tmp31_);
	_tmp33_ = _tmp32_;
	_tmp35_ = _tmp34_ = g_regex_split_simple ("\\s+", _tmp33_, 0, 0);
	_tmp36_ = _tmp35_;
	_tmp36__length1 = _vala_array_length (_tmp34_);
	_g_free0 (_tmp33_);
	individual_words = _tmp36_;
	individual_words_length1 = _tmp36__length1;
	_individual_words_size_ = individual_words_length1;
	_tmp37_ = individual_words;
	_tmp37__length1 = individual_words_length1;
	if (_tmp37__length1 >= 2) {
		gchar** _tmp38_ = NULL;
		gchar** escaped_words;
		gint escaped_words_length1;
		gint _escaped_words_size_;
		gchar** _tmp39_;
		gint _tmp39__length1;
		gchar** _tmp43_;
		gint _tmp43__length1;
		gchar* _tmp44_ = NULL;
		gchar* _tmp45_;
		gchar* _tmp46_ = NULL;
		gchar* _tmp47_;
		gchar* pattern;
		SynapseMatcherFlags _tmp53_;
		_tmp38_ = g_new0 (gchar*, 0 + 1);
		escaped_words = _tmp38_;
		escaped_words_length1 = 0;
		_escaped_words_size_ = escaped_words_length1;
		_tmp39_ = individual_words;
		_tmp39__length1 = individual_words_length1;
		{
			gchar** word_collection = NULL;
			gint word_collection_length1 = 0;
			gint _word_collection_size_ = 0;
			gint word_it = 0;
			word_collection = _tmp39_;
			word_collection_length1 = _tmp39__length1;
			for (word_it = 0; word_it < _tmp39__length1; word_it = word_it + 1) {
				const gchar* word = NULL;
				word = word_collection[word_it];
				{
					gchar** _tmp40_;
					gint _tmp40__length1;
					const gchar* _tmp41_;
					gchar* _tmp42_ = NULL;
					_tmp40_ = escaped_words;
					_tmp40__length1 = escaped_words_length1;
					_tmp41_ = word;
					_tmp42_ = g_regex_escape_string (_tmp41_, -1);
					_vala_array_add6 (&escaped_words, &escaped_words_length1, &_escaped_words_size_, _tmp42_);
				}
			}
		}
		_tmp43_ = escaped_words;
		_tmp43__length1 = escaped_words_length1;
		_tmp44_ = g_strjoinv (").+\\b(", _tmp43_);
		_tmp45_ = _tmp44_;
		_tmp46_ = g_strdup_printf ("\\b(%s)", _tmp45_);
		_tmp47_ = _tmp46_;
		_g_free0 (_tmp45_);
		pattern = _tmp47_;
		{
			const gchar* _tmp48_;
			GRegexCompileFlags _tmp49_;
			GRegex* _tmp50_;
			GRegex* _tmp51_;
			GRegex* _tmp52_;
			_tmp48_ = pattern;
			_tmp49_ = flags;
			_tmp50_ = g_regex_new (_tmp48_, _tmp49_, 0, &_inner_error_);
			_tmp51_ = _tmp50_;
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == G_REGEX_ERROR) {
					goto __catch19_g_regex_error;
				}
				_g_free0 (pattern);
				escaped_words = (_vala_array_free (escaped_words, escaped_words_length1, (GDestroyNotify) g_free), NULL);
				individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
				_g_regex_unref0 (re);
				_g_object_unref0 (results);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
			_g_regex_unref0 (re);
			re = _tmp51_;
			_tmp52_ = re;
			gee_abstract_map_set ((GeeAbstractMap*) results, _tmp52_, (gpointer) ((gintptr) ((gint) SYNAPSE_MATCH_SCORE_GOOD)));
		}
		goto __finally19;
		__catch19_g_regex_error:
		{
			GError* err = NULL;
			err = _inner_error_;
			_inner_error_ = NULL;
			_g_error_free0 (err);
		}
		__finally19:
		if (_inner_error_ != NULL) {
			_g_free0 (pattern);
			escaped_words = (_vala_array_free (escaped_words, escaped_words_length1, (GDestroyNotify) g_free), NULL);
			individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
			_g_regex_unref0 (re);
			_g_object_unref0 (results);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_tmp53_ = match_flags;
		if (!((_tmp53_ & SYNAPSE_MATCHER_FLAGS_NO_REVERSED) == SYNAPSE_MATCHER_FLAGS_NO_REVERSED)) {
			gchar** _tmp54_;
			gint _tmp54__length1;
			_tmp54_ = escaped_words;
			_tmp54__length1 = escaped_words_length1;
			if (_tmp54__length1 == 2) {
				gchar** _tmp55_;
				gint _tmp55__length1;
				const gchar* _tmp56_;
				gchar** _tmp57_;
				gint _tmp57__length1;
				const gchar* _tmp58_;
				gchar* _tmp59_ = NULL;
				gchar* _tmp60_;
				gchar* _tmp61_ = NULL;
				gchar* _tmp62_;
				gchar* reversed;
				_tmp55_ = escaped_words;
				_tmp55__length1 = escaped_words_length1;
				_tmp56_ = _tmp55_[1];
				_tmp57_ = escaped_words;
				_tmp57__length1 = escaped_words_length1;
				_tmp58_ = _tmp57_[0];
				_tmp59_ = g_strjoin (").+\\b(", _tmp56_, _tmp58_, NULL, NULL);
				_tmp60_ = _tmp59_;
				_tmp61_ = g_strdup_printf ("\\b(%s)", _tmp60_);
				_tmp62_ = _tmp61_;
				_g_free0 (_tmp60_);
				reversed = _tmp62_;
				{
					const gchar* _tmp63_;
					GRegexCompileFlags _tmp64_;
					GRegex* _tmp65_;
					GRegex* _tmp66_;
					GRegex* _tmp67_;
					_tmp63_ = reversed;
					_tmp64_ = flags;
					_tmp65_ = g_regex_new (_tmp63_, _tmp64_, 0, &_inner_error_);
					_tmp66_ = _tmp65_;
					if (_inner_error_ != NULL) {
						if (_inner_error_->domain == G_REGEX_ERROR) {
							goto __catch20_g_regex_error;
						}
						_g_free0 (reversed);
						_g_free0 (pattern);
						escaped_words = (_vala_array_free (escaped_words, escaped_words_length1, (GDestroyNotify) g_free), NULL);
						individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
						_g_regex_unref0 (re);
						_g_object_unref0 (results);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
					_g_regex_unref0 (re);
					re = _tmp66_;
					_tmp67_ = re;
					gee_abstract_map_set ((GeeAbstractMap*) results, _tmp67_, (gpointer) ((gintptr) ((gint) (SYNAPSE_MATCH_SCORE_GOOD - SYNAPSE_MATCH_SCORE_INCREMENT_MINOR))));
				}
				goto __finally20;
				__catch20_g_regex_error:
				{
					GError* err = NULL;
					err = _inner_error_;
					_inner_error_ = NULL;
					_g_error_free0 (err);
				}
				__finally20:
				if (_inner_error_ != NULL) {
					_g_free0 (reversed);
					_g_free0 (pattern);
					escaped_words = (_vala_array_free (escaped_words, escaped_words_length1, (GDestroyNotify) g_free), NULL);
					individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
					_g_regex_unref0 (re);
					_g_object_unref0 (results);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
				_g_free0 (reversed);
			} else {
				gchar** _tmp68_;
				gint _tmp68__length1;
				gchar* _tmp69_ = NULL;
				gchar* _tmp70_;
				gchar* _tmp71_ = NULL;
				gchar* _tmp72_;
				gchar* orred;
				gchar* _tmp73_;
				gchar* any_order;
				_tmp68_ = escaped_words;
				_tmp68__length1 = escaped_words_length1;
				_tmp69_ = g_strjoinv (")|(?:", _tmp68_);
				_tmp70_ = _tmp69_;
				_tmp71_ = g_strdup_printf ("\\b((?:%s))", _tmp70_);
				_tmp72_ = _tmp71_;
				_g_free0 (_tmp70_);
				orred = _tmp72_;
				_tmp73_ = g_strdup ("");
				any_order = _tmp73_;
				{
					gint i;
					i = 0;
					{
						gboolean _tmp74_;
						_tmp74_ = TRUE;
						while (TRUE) {
							gboolean _tmp75_;
							gint _tmp77_;
							gchar** _tmp78_;
							gint _tmp78__length1;
							gint _tmp79_;
							gchar** _tmp80_;
							gint _tmp80__length1;
							gboolean is_last;
							const gchar* _tmp81_;
							const gchar* _tmp82_;
							gchar* _tmp83_;
							gboolean _tmp84_;
							_tmp75_ = _tmp74_;
							if (!_tmp75_) {
								gint _tmp76_;
								_tmp76_ = i;
								i = _tmp76_ + 1;
							}
							_tmp74_ = FALSE;
							_tmp77_ = i;
							_tmp78_ = escaped_words;
							_tmp78__length1 = escaped_words_length1;
							if (!(_tmp77_ < _tmp78__length1)) {
								break;
							}
							_tmp79_ = i;
							_tmp80_ = escaped_words;
							_tmp80__length1 = escaped_words_length1;
							is_last = _tmp79_ == (_tmp80__length1 - 1);
							_tmp81_ = any_order;
							_tmp82_ = orred;
							_tmp83_ = g_strconcat (_tmp81_, _tmp82_, NULL);
							_g_free0 (any_order);
							any_order = _tmp83_;
							_tmp84_ = is_last;
							if (!_tmp84_) {
								const gchar* _tmp85_;
								gchar* _tmp86_;
								_tmp85_ = any_order;
								_tmp86_ = g_strconcat (_tmp85_, ".+", NULL);
								_g_free0 (any_order);
								any_order = _tmp86_;
							}
						}
					}
				}
				{
					const gchar* _tmp87_;
					GRegexCompileFlags _tmp88_;
					GRegex* _tmp89_;
					GRegex* _tmp90_;
					GRegex* _tmp91_;
					_tmp87_ = any_order;
					_tmp88_ = flags;
					_tmp89_ = g_regex_new (_tmp87_, _tmp88_, 0, &_inner_error_);
					_tmp90_ = _tmp89_;
					if (_inner_error_ != NULL) {
						if (_inner_error_->domain == G_REGEX_ERROR) {
							goto __catch21_g_regex_error;
						}
						_g_free0 (any_order);
						_g_free0 (orred);
						_g_free0 (pattern);
						escaped_words = (_vala_array_free (escaped_words, escaped_words_length1, (GDestroyNotify) g_free), NULL);
						individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
						_g_regex_unref0 (re);
						_g_object_unref0 (results);
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
						g_clear_error (&_inner_error_);
						return NULL;
					}
					_g_regex_unref0 (re);
					re = _tmp90_;
					_tmp91_ = re;
					gee_abstract_map_set ((GeeAbstractMap*) results, _tmp91_, (gpointer) ((gintptr) ((gint) (SYNAPSE_MATCH_SCORE_AVERAGE + SYNAPSE_MATCH_SCORE_INCREMENT_MINOR))));
				}
				goto __finally21;
				__catch21_g_regex_error:
				{
					GError* err = NULL;
					err = _inner_error_;
					_inner_error_ = NULL;
					_g_error_free0 (err);
				}
				__finally21:
				if (_inner_error_ != NULL) {
					_g_free0 (any_order);
					_g_free0 (orred);
					_g_free0 (pattern);
					escaped_words = (_vala_array_free (escaped_words, escaped_words_length1, (GDestroyNotify) g_free), NULL);
					individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
					_g_regex_unref0 (re);
					_g_object_unref0 (results);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return NULL;
				}
				_g_free0 (any_order);
				_g_free0 (orred);
			}
		}
		_g_free0 (pattern);
		escaped_words = (_vala_array_free (escaped_words, escaped_words_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp92_ = match_flags;
	if (!((_tmp92_ & SYNAPSE_MATCHER_FLAGS_NO_SUBSTRING) == SYNAPSE_MATCHER_FLAGS_NO_SUBSTRING)) {
		{
			const gchar* _tmp93_;
			gchar* _tmp94_ = NULL;
			gchar* _tmp95_;
			gchar* _tmp96_ = NULL;
			gchar* _tmp97_;
			GRegexCompileFlags _tmp98_;
			GRegex* _tmp99_;
			GRegex* _tmp100_;
			GRegex* _tmp101_;
			GRegex* _tmp102_;
			_tmp93_ = query;
			_tmp94_ = g_regex_escape_string (_tmp93_, -1);
			_tmp95_ = _tmp94_;
			_tmp96_ = g_strdup_printf ("(%s)", _tmp95_);
			_tmp97_ = _tmp96_;
			_tmp98_ = flags;
			_tmp99_ = g_regex_new (_tmp97_, _tmp98_, 0, &_inner_error_);
			_tmp100_ = _tmp99_;
			_g_free0 (_tmp97_);
			_g_free0 (_tmp95_);
			_tmp101_ = _tmp100_;
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == G_REGEX_ERROR) {
					goto __catch22_g_regex_error;
				}
				individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
				_g_regex_unref0 (re);
				_g_object_unref0 (results);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
			_g_regex_unref0 (re);
			re = _tmp101_;
			_tmp102_ = re;
			gee_abstract_map_set ((GeeAbstractMap*) results, _tmp102_, (gpointer) ((gintptr) ((gint) SYNAPSE_MATCH_SCORE_BELOW_AVERAGE)));
		}
		goto __finally22;
		__catch22_g_regex_error:
		{
			GError* err = NULL;
			err = _inner_error_;
			_inner_error_ = NULL;
			_g_error_free0 (err);
		}
		__finally22:
		if (_inner_error_ != NULL) {
			individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
			_g_regex_unref0 (re);
			_g_object_unref0 (results);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp103_ = query;
	_tmp105_ = _tmp104_ = g_regex_split_simple ("\\s*", _tmp103_, 0, 0);
	individual_chars = _tmp105_;
	individual_chars_length1 = _vala_array_length (_tmp104_);
	_individual_chars_size_ = individual_chars_length1;
	_tmp106_ = g_new0 (gchar*, 0 + 1);
	escaped_chars = _tmp106_;
	escaped_chars_length1 = 0;
	_escaped_chars_size_ = escaped_chars_length1;
	_tmp107_ = individual_chars;
	_tmp107__length1 = individual_chars_length1;
	{
		gchar** word_collection = NULL;
		gint word_collection_length1 = 0;
		gint _word_collection_size_ = 0;
		gint word_it = 0;
		word_collection = _tmp107_;
		word_collection_length1 = _tmp107__length1;
		for (word_it = 0; word_it < _tmp107__length1; word_it = word_it + 1) {
			const gchar* word = NULL;
			word = word_collection[word_it];
			{
				gchar** _tmp108_;
				gint _tmp108__length1;
				const gchar* _tmp109_;
				gchar* _tmp110_ = NULL;
				_tmp108_ = escaped_chars;
				_tmp108__length1 = escaped_chars_length1;
				_tmp109_ = word;
				_tmp110_ = g_regex_escape_string (_tmp109_, -1);
				_vala_array_add7 (&escaped_chars, &escaped_chars_length1, &_escaped_chars_size_, _tmp110_);
			}
		}
	}
	_tmp113_ = match_flags;
	if (!((_tmp113_ & SYNAPSE_MATCHER_FLAGS_NO_PARTIAL) == SYNAPSE_MATCHER_FLAGS_NO_PARTIAL)) {
		gchar** _tmp114_;
		gint _tmp114__length1;
		_tmp114_ = individual_words;
		_tmp114__length1 = individual_words_length1;
		_tmp112_ = _tmp114__length1 == 1;
	} else {
		_tmp112_ = FALSE;
	}
	_tmp115_ = _tmp112_;
	if (_tmp115_) {
		gchar** _tmp116_;
		gint _tmp116__length1;
		_tmp116_ = individual_chars;
		_tmp116__length1 = individual_chars_length1;
		_tmp111_ = _tmp116__length1 <= 5;
	} else {
		_tmp111_ = FALSE;
	}
	_tmp117_ = _tmp111_;
	if (_tmp117_) {
		gchar** _tmp118_;
		gint _tmp118__length1;
		gchar* _tmp119_ = NULL;
		gchar* _tmp120_;
		gchar* _tmp121_ = NULL;
		gchar* _tmp122_;
		gchar* pattern;
		_tmp118_ = escaped_chars;
		_tmp118__length1 = escaped_chars_length1;
		_tmp119_ = g_strjoinv (").+\\b(", _tmp118_);
		_tmp120_ = _tmp119_;
		_tmp121_ = g_strdup_printf ("\\b(%s)", _tmp120_);
		_tmp122_ = _tmp121_;
		_g_free0 (_tmp120_);
		pattern = _tmp122_;
		{
			const gchar* _tmp123_;
			GRegexCompileFlags _tmp124_;
			GRegex* _tmp125_;
			GRegex* _tmp126_;
			GRegex* _tmp127_;
			_tmp123_ = pattern;
			_tmp124_ = flags;
			_tmp125_ = g_regex_new (_tmp123_, _tmp124_, 0, &_inner_error_);
			_tmp126_ = _tmp125_;
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == G_REGEX_ERROR) {
					goto __catch23_g_regex_error;
				}
				_g_free0 (pattern);
				escaped_chars = (_vala_array_free (escaped_chars, escaped_chars_length1, (GDestroyNotify) g_free), NULL);
				individual_chars = (_vala_array_free (individual_chars, individual_chars_length1, (GDestroyNotify) g_free), NULL);
				individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
				_g_regex_unref0 (re);
				_g_object_unref0 (results);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
			_g_regex_unref0 (re);
			re = _tmp126_;
			_tmp127_ = re;
			gee_abstract_map_set ((GeeAbstractMap*) results, _tmp127_, (gpointer) ((gintptr) ((gint) SYNAPSE_MATCH_SCORE_ABOVE_AVERAGE)));
		}
		goto __finally23;
		__catch23_g_regex_error:
		{
			GError* err = NULL;
			err = _inner_error_;
			_inner_error_ = NULL;
			_g_error_free0 (err);
		}
		__finally23:
		if (_inner_error_ != NULL) {
			_g_free0 (pattern);
			escaped_chars = (_vala_array_free (escaped_chars, escaped_chars_length1, (GDestroyNotify) g_free), NULL);
			individual_chars = (_vala_array_free (individual_chars, individual_chars_length1, (GDestroyNotify) g_free), NULL);
			individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
			_g_regex_unref0 (re);
			_g_object_unref0 (results);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_g_free0 (pattern);
	}
	_tmp129_ = match_flags;
	if (!((_tmp129_ & SYNAPSE_MATCHER_FLAGS_NO_FUZZY) == SYNAPSE_MATCHER_FLAGS_NO_FUZZY)) {
		gchar** _tmp130_;
		gint _tmp130__length1;
		_tmp130_ = escaped_chars;
		_tmp130__length1 = escaped_chars_length1;
		_tmp128_ = _tmp130__length1 > 0;
	} else {
		_tmp128_ = FALSE;
	}
	_tmp131_ = _tmp128_;
	if (_tmp131_) {
		gchar** _tmp132_;
		gint _tmp132__length1;
		gchar* _tmp133_ = NULL;
		gchar* _tmp134_;
		gchar* _tmp135_ = NULL;
		gchar* _tmp136_;
		gchar* pattern;
		_tmp132_ = escaped_chars;
		_tmp132__length1 = escaped_chars_length1;
		_tmp133_ = g_strjoinv (").*(", _tmp132_);
		_tmp134_ = _tmp133_;
		_tmp135_ = g_strdup_printf ("\\b(%s)", _tmp134_);
		_tmp136_ = _tmp135_;
		_g_free0 (_tmp134_);
		pattern = _tmp136_;
		{
			const gchar* _tmp137_;
			GRegexCompileFlags _tmp138_;
			GRegex* _tmp139_;
			GRegex* _tmp140_;
			GRegex* _tmp141_;
			_tmp137_ = pattern;
			_tmp138_ = flags;
			_tmp139_ = g_regex_new (_tmp137_, _tmp138_, 0, &_inner_error_);
			_tmp140_ = _tmp139_;
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == G_REGEX_ERROR) {
					goto __catch24_g_regex_error;
				}
				_g_free0 (pattern);
				escaped_chars = (_vala_array_free (escaped_chars, escaped_chars_length1, (GDestroyNotify) g_free), NULL);
				individual_chars = (_vala_array_free (individual_chars, individual_chars_length1, (GDestroyNotify) g_free), NULL);
				individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
				_g_regex_unref0 (re);
				_g_object_unref0 (results);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
			_g_regex_unref0 (re);
			re = _tmp140_;
			_tmp141_ = re;
			gee_abstract_map_set ((GeeAbstractMap*) results, _tmp141_, (gpointer) ((gintptr) ((gint) SYNAPSE_MATCH_SCORE_POOR)));
		}
		goto __finally24;
		__catch24_g_regex_error:
		{
			GError* err = NULL;
			err = _inner_error_;
			_inner_error_ = NULL;
			_g_error_free0 (err);
		}
		__finally24:
		if (_inner_error_ != NULL) {
			_g_free0 (pattern);
			escaped_chars = (_vala_array_free (escaped_chars, escaped_chars_length1, (GDestroyNotify) g_free), NULL);
			individual_chars = (_vala_array_free (individual_chars, individual_chars_length1, (GDestroyNotify) g_free), NULL);
			individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
			_g_regex_unref0 (re);
			_g_object_unref0 (results);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
		_g_free0 (pattern);
	}
	_tmp142_ = gee_array_list_new (GEE_MAP_TYPE_ENTRY, (GBoxedCopyFunc) g_object_ref, g_object_unref, NULL);
	sorted_results = _tmp142_;
	_tmp143_ = gee_abstract_map_get_entries ((GeeMap*) results);
	_tmp144_ = _tmp143_;
	entries = _tmp144_;
	_tmp145_ = _g_object_ref0 (entries);
	g_object_set_data_full ((GObject*) sorted_results, "entries-ref", _tmp145_, g_object_unref);
	gee_abstract_collection_add_all ((GeeAbstractCollection*) sorted_results, (GeeCollection*) entries);
	gee_list_sort ((GeeList*) sorted_results, ___lambda3__gcompare_func);
	result = (GeeList*) sorted_results;
	_g_object_unref0 (entries);
	escaped_chars = (_vala_array_free (escaped_chars, escaped_chars_length1, (GDestroyNotify) g_free), NULL);
	individual_chars = (_vala_array_free (individual_chars, individual_chars_length1, (GDestroyNotify) g_free), NULL);
	individual_words = (_vala_array_free (individual_words, individual_words_length1, (GDestroyNotify) g_free), NULL);
	_g_regex_unref0 (re);
	_g_object_unref0 (results);
	return result;
}


void synapse_query_copy (const SynapseQuery* self, SynapseQuery* dest) {
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GCancellable* _tmp4_;
	GCancellable* _tmp5_;
	SynapseQueryFlags _tmp6_;
	guint _tmp7_;
	guint _tmp8_;
	_tmp0_ = (*self).query_string;
	_tmp1_ = g_strdup (_tmp0_);
	_g_free0 ((*dest).query_string);
	(*dest).query_string = _tmp1_;
	_tmp2_ = (*self).query_string_folded;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 ((*dest).query_string_folded);
	(*dest).query_string_folded = _tmp3_;
	_tmp4_ = (*self).cancellable;
	_tmp5_ = _g_object_ref0 (_tmp4_);
	_g_object_unref0 ((*dest).cancellable);
	(*dest).cancellable = _tmp5_;
	_tmp6_ = (*self).query_type;
	(*dest).query_type = _tmp6_;
	_tmp7_ = (*self).max_results;
	(*dest).max_results = _tmp7_;
	_tmp8_ = (*self).query_id;
	(*dest).query_id = _tmp8_;
}


void synapse_query_destroy (SynapseQuery* self) {
	_g_free0 ((*self).query_string);
	_g_free0 ((*self).query_string_folded);
	_g_object_unref0 ((*self).cancellable);
}


SynapseQuery* synapse_query_dup (const SynapseQuery* self) {
	SynapseQuery* dup;
	dup = g_new0 (SynapseQuery, 1);
	synapse_query_copy (self, dup);
	return dup;
}


void synapse_query_free (SynapseQuery* self) {
	synapse_query_destroy (self);
	g_free (self);
}


GType synapse_query_get_type (void) {
	static volatile gsize synapse_query_type_id__volatile = 0;
	if (g_once_init_enter (&synapse_query_type_id__volatile)) {
		GType synapse_query_type_id;
		synapse_query_type_id = g_boxed_type_register_static ("SynapseQuery", (GBoxedCopyFunc) synapse_query_dup, (GBoxedFreeFunc) synapse_query_free);
		g_once_init_leave (&synapse_query_type_id__volatile, synapse_query_type_id);
	}
	return synapse_query_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



